ghc-8.2.2: The GHC API

Safe Haskell | None
Language | Haskell2010

FunDeps

# Documentation

data FunDepEqn loc #

Constructors

FDEqn |

Fields

- fd_qtvs :: [TyVar]
- fd_eqs :: [TypeEqn]
- fd_pred1 :: PredType
- fd_pred2 :: PredType
- fd_loc :: loc

Instances

Outputable (FunDepEqn a) # |
Methods ppr :: FunDepEqn a -> SDoc # pprPrec :: Rational -> FunDepEqn a -> SDoc #

pprEquation :: FunDepEqn a -> SDoc #

improveFromInstEnv :: InstEnvs -> (PredType -> SrcSpan -> loc) -> PredType -> [FunDepEqn loc] #

improveFromAnother :: loc -> PredType -> PredType -> [FunDepEqn loc] #

checkInstCoverage :: Bool -> Class -> [PredType] -> [Type] -> Validity #

checkFunDeps :: InstEnvs -> ClsInst -> [ClsInst] #

pprFundeps :: Outputable a => [FunDep a] -> SDoc #